diff -ur old/ipkg.h.in new/ipkg.h.in
--- old/ipkg.h.in	2006-02-06 09:13:01.000000000 +0100
+++ new/ipkg.h.in	2009-12-18 20:07:26.000000000 +0100
@@ -62,7 +62,7 @@
     struct errlist * next;
 } ;
 
-struct errlist* error_list;
+static struct errlist* error_list;
 
 
 #endif
diff -ur old/ipkg_utils.c new/ipkg_utils.c
--- old/ipkg_utils.c	2006-02-06 09:13:02.000000000 +0100
+++ new/ipkg_utils.c	2009-12-18 19:58:07.000000000 +0100
@@ -18,12 +18,32 @@
 #include "ipkg.h"
 #include <errno.h>
 #include <ctype.h>
-#include <sys/vfs.h>
+#ifndef __APPLE__
+#include <sys/statfs.h>
+#else
+#include <sys/mount.h>
+#endif
 
 #include "ipkg_utils.h"
 #include "pkg.h"
 #include "pkg_hash.h"
 
+#ifndef HAVE_STRNDUP
+
+char *strndup(const char *orig, size_t len) {
+    const size_t orig_len = (orig == NULL) ? 0: strlen(orig);
+    const size_t new_len = MIN(orig_len, len);
+    char *out = malloc(new_len+1);
+
+    if (out == NULL)
+        return NULL;
+
+    out[new_len] = '\0';
+    return memcpy(out, orig, new_len);
+}
+
+#endif
+
 void print_pkg_status(pkg_t * pkg, FILE * file);
 
 int get_available_blocks(char * filesystem)
diff -ur old/libbb/libbb.h new/libbb/libbb.h
--- old/libbb/libbb.h	2006-02-06 09:13:02.000000000 +0100
+++ new/libbb/libbb.h	2009-12-18 19:55:01.000000000 +0100
@@ -50,7 +50,9 @@
 #include "dmalloc.h"
 #endif
 
+#ifndef __APPLE__
 #include <features.h>
+#endif
 
 #if (__GNU_LIBRARY__ < 5) && (!defined __dietlibc__)
 /* libc5 doesn't define socklen_t */
diff -ur old/md5.c new/md5.c
--- old/md5.c	2006-02-06 09:13:04.000000000 +0100
+++ new/md5.c	2009-12-18 19:57:39.000000000 +0100
@@ -50,7 +50,9 @@
 #include <getopt.h>
 #include <stdlib.h>
 #include <string.h>
+#ifndef __APPLE__
 #include <endian.h>
+#endif
 #include <sys/types.h>
 #if defined HAVE_LIMITS_H
 # include <limits.h>
